package com.spket.test;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;

import com.spket.g2d.G2DRenderingHints;

public class FixedLineWidthPart extends Part {
	private static final float[] dashs = { 2, 1, 3 };

	private static class FixedLineWidth extends Renderer {
		public void render(Graphics2D g2, boolean awt, int w, int h) {
			float sx = 10, sy = 20;
			float w1 = ((float) w) / 2 / sx;
			float h1 = ((float) h) / 2 / sy;
			
			g2.scale(sx, sy);
			g2.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER, 10.0f, dashs, 0.0f));
			draw(g2, w1, h1, false);
			
			g2.translate(w1, 0);
			if (!awt)
				g2.setRenderingHint(G2DRenderingHints.KEY_FIXED_LINE_WIDTH, G2DRenderingHints.VALUE_FIXED_LINE_WIDTH_ON);
				
			draw(g2, w1, h1, awt);
			
			if (!awt)
				g2.setRenderingHint(G2DRenderingHints.KEY_FIXED_LINE_WIDTH, G2DRenderingHints.VALUE_FIXED_LINE_WIDTH_OFF);
			
			g2.setStroke(new BasicStroke(2.0f));
			g2.setPaint(new GradientPaint(0, 0, Color.red, w1, h1, Color.blue, true));
			g2.translate(-w1, h1);
			draw(g2, w1, h1, false);
			g2.translate(w1, 0);
			g2.setStroke(new BasicStroke(5.0f));
			if (!awt)
				g2.setRenderingHint(G2DRenderingHints.KEY_FIXED_LINE_WIDTH, G2DRenderingHints.VALUE_FIXED_LINE_WIDTH_ON);
				
			draw(g2, w1, h1, awt);
		}
		
		protected void draw(Graphics2D g2, float w, float h, boolean trans) {
			if (w < 3 || h < 5)
				return;
			
			Ellipse2D.Float ep = new Ellipse2D.Float(1, 2, w - 3, h - 5);
			if (trans) {
				draw(g2, ep);
			} else {
				g2.draw(ep);
			}
		}
	}
	
	protected Renderer createRenderer() {
		return new FixedLineWidth();
	}
}
