package com.spket.test;

import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParserFactory;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.xml.sax.Attributes;
import org.xml.sax.ContentHandler;
import org.xml.sax.InputSource;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

public class MenuLoader implements ContentHandler {
	private static final String T_MENU = "menu";
	private static final String T_ITEM = "item";
	
	private static final String A_TEXT = "text";
	private static final String A_PART = "part";
	
	private Menu menu;
	private Menu submenu;
	private Listener listener;
	
	public void characters(char[] ch, int start, int length) throws SAXException {
	}

	public void endDocument() throws SAXException {
	}

	public void endElement(String uri, String localName, String qName) throws SAXException {
	}

	public void endPrefixMapping(String prefix) throws SAXException {
	}

	public void ignorableWhitespace(char[] ch, int start, int length) throws SAXException {
	}

	public void processingInstruction(String target, String data) throws SAXException {
	}

	public void setDocumentLocator(Locator locator) {
	}

	public void skippedEntity(String name) throws SAXException {
	}

	public void startDocument() throws SAXException {
	}

	public void startElement(String uri, String localName, String qName, Attributes atts) throws SAXException {
		if (T_MENU.equals(qName)) {
			MenuItem item = new MenuItem(menu, SWT.CASCADE);
			item.setText(atts.getValue(A_TEXT));
			submenu = new Menu(menu.getParent(), SWT.DROP_DOWN);
			item.setMenu(submenu);
		} else if (T_ITEM.equals(qName)) {
			if (atts.getLength() == 0) {
				new MenuItem(submenu, SWT.SEPARATOR);
			} else {
				MenuItem item = new MenuItem(submenu, SWT.PUSH);
				item.setText(atts.getValue(A_TEXT));
				item.setData(atts.getValue(A_PART));
				item.addListener(SWT.Selection, listener);
			}
		}
	}

	public void startPrefixMapping(String prefix, String uri) throws SAXException {
	}
	
	public void initMenu(Menu menu, Listener listener) throws SAXException, ParserConfigurationException, IOException {
		this.menu = menu;
		this.listener = listener;
		InputStream in = getClass().getResourceAsStream("/com/spket/test/menu.xml");
		if (in != null) {
			SAXParserFactory f = SAXParserFactory.newInstance();
			f.setNamespaceAware(true);
			XMLReader parser = f.newSAXParser().getXMLReader();
			parser.setContentHandler(this);
			parser.parse(new InputSource(in));
		}
	}
}
